//!	EOS_RxStub.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_RxStub_h_
#define _EOS_RxStub_h_


//--------------------------- include section -----------------------
#include "EOS.h"


//--------------------------- class definition ----------------------
//! CEOS_RxStub represents the receiving stub with a certain data
//! type
//! \code
//! class CEOS_USART :
//!     public CEOS_RxStub<BYTE>,
//!     public CEOS_TxStub<BYTE>
//! \endcode
template <class TYPE>
class CEOS_RxStub
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_RxStub);


//--------------------------- event sources -------------------------
public:
    // m_RxEvent ----------------------------------------------------
    //! whenever data is available the event is triggered
    CEOS_Event<TYPE> m_RxEvent;
};


#endif
