//!	EOS_Serial.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_Serial_h_
#define _EOS_Serial_h_


//--------------------------- include section -----------------------
#include "EOS_Event.h"
#include "types.h"


//--------------------------- class definition ----------------------
class CEOS_Serial
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    inline CEOS_Serial() :
    	m_bBusy(false)
    {
        // Nothing to do
    }

    // destructor ---------------------------------------------------
    //!	\brief	destructor has nothing to do
    inline ~CEOS_Serial()
    {
        // Nothing to do
    }

    // lock copy and assignment -------------------------------------
private:
    CEOS_Serial(const CEOS_Serial& EOS_Serial);
    const CEOS_Serial& operator = (const CEOS_Serial& EOS_Serial);


//--------------------------- public access -------------------------
public:
    // busy ---------------------------------------------------------
    inline bool_t busy() const
    {
    	return m_bBusy;
    }


//--------------------------- public virtual access -----------------
public:
    // writeByte ----------------------------------------------------
    virtual void writeByte(BYTE btByte) = 0;

    // readByte -----------------------------------------------------
    virtual BYTE readByte() = 0;


//--------------------------- public data ---------------------------
public:
	// m_EventRx ----------------------------------------------------
    CEOS_Event m_EventRx;

	// m_EventTx ----------------------------------------------------
    CEOS_Event m_EventTx;

	// m_bBusy ------------------------------------------------------
	bool_t m_bBusy;
};


#endif
