//!	EOS_TxStub.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_TxStub_h_
#define _EOS_TxStub_h_


//--------------------------- include section -----------------------
#include "EOS.h"
#include <stdarg.h>


//--------------------------- class definition ----------------------
//! CEOS_RxStub represents the sending stub with a certain data
//! type
//! \code
//! class CEOS_USART :
//!     public CEOS_RxStub<BYTE>,
//!     public CEOS_TxStub<BYTE>
//! \endcode
template <class TYPE>
class CEOS_TxStub
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CEOS_TxStub);


//--------------------------- public virtual access -----------------
public:
    // write --------------------------------------------------------
    //! pure virtual function to write one data type to the stub
    virtual void write(const TYPE btData) = 0;

//--------------------------- event sources -------------------------
public:
    // m_TxEvent ----------------------------------------------------
    //! event signalling that the transmission is finished
    CEOS_Event<> m_TxEvent;
};


#endif
